//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  C'216,234,243'
#property indicator_color2  MistyRose
#property indicator_color3  DarkGray
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern int  FastEMA      = 12;
extern int  SlowEMA      = 26;
extern int  SignalEMA    =  9;
extern bool ColorOnSlope = false;
extern int  Price        = PRICE_CLOSE;

//
//
//
//
//

double macd[];
double macdda[];
double macddb[];
double leader[];
double leaderhu[];
double leaderhd[];
double signal[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,leaderhu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,leaderhd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,leader);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,macdda);
   SetIndexBuffer(5,macddb);
   SetIndexBuffer(6,signal);
      IndicatorShortName("Leader of the MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit() { return(0); }


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][5];
#define _ema10 0
#define _ema11 1
#define _ema20 2
#define _ema21 3
#define _color 4

int start()
{
   int i,r,counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);
            if (work[Bars-limit-1][_color]==-1) CleanPoint(limit,macdda,macddb);
 
   //
   //
   //
   //
   //
 
   double fastAlpha   = 2.0/(1.0+FastEMA);
   double slowAlpha   = 2.0/(1.0+SlowEMA);
   double signalAlpha = 2.0/(1.0+SignalEMA);

      //
      //
      //
      //
      //
         
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            work[r][_color] = work[r-1][_color];
            work[r][_ema10] = work[r-1][_ema10]+fastAlpha*(price                -work[r-1][_ema10]);
            work[r][_ema11] = work[r-1][_ema11]+fastAlpha*(price-work[r][_ema10]-work[r-1][_ema11]);
            work[r][_ema20] = work[r-1][_ema20]+slowAlpha*(price                -work[r-1][_ema20]);
            work[r][_ema21] = work[r-1][_ema21]+slowAlpha*(price-work[r][_ema20]-work[r-1][_ema21]);
            macd[i]         = work[r][_ema10]-work[r][_ema20];
            leader[i]       = work[r][_ema11]-work[r][_ema21]+macd[i];
            signal[i]       = signal[i+1]+signalAlpha*(macd[i]-signal[i+1]);
            
            //
            //
            //
            //
            //
            
            leaderhu[i] = EMPTY_VALUE;
            leaderhd[i] = EMPTY_VALUE;
            macdda[i]   = EMPTY_VALUE;
            macddb[i]   = EMPTY_VALUE;
               if (leader[i] > 0) leaderhu[i] = leader[i];
               if (leader[i] < 0) leaderhd[i] = leader[i];
               if (ColorOnSlope)
               {
                  if (macd[i]>macd[i+1]) work[r][_color] =  1;
                  if (macd[i]<macd[i+1]) work[r][_color] = -1;
               }
               else
               {
                  if (macd[i]>signal[i]) work[r][_color] =  1;
                  if (macd[i]<signal[i]) work[r][_color] = -1;
               }
               if (work[r][_color]==-1) PlotPoint(i,macdda,macddb,macd);
      }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

